from gstreamer import *
import asyncio, websockets, time, json


url = "ws://cobot.center:8286/pang/ws/pub?channel=instant&name=test&track=colink&mode=bundle"
cam = Camera("RPi 4", 1, 1280, 720, 30, 5000000)


mode = "high"
change = "high"
async def send(ws):
	print("send")
	global mode
#	await ws.send("video/h264;width=1280;height=720;framerate=30;codecs=avc1.42002A")
	await ws.send("video/h265;width=1280;height=720;framerate=30;codecs=hvc1.1.6.L123.00")
	while True:
		if mode == "high":
			image = cam.getImageh()
		elif mode == "mid":
			image = cam.getImagem()
		elif mode == "low":
			image = cam.getImagel()

		if mode != change and change == "high":
			change_image = cam.getImageh()
#			nal_unit = change_image[10] & 0x1F	# h264
			nal_unit = change_image[4] & 0x1F	# h265
			print("Nal Unit: ", nal_unit)
#			if nal_unit == 7:	# h264
			if nal_unit == 0:	# h265
				print("change mode")
				image = change_image
				mode = change
		elif mode != change and change == "mid":
			change_image = cam.getImagem()
#			nal_unit = change_image[10] & 0x1F
			nal_unit = change_image[4] & 0x1F
			print("Nal Unit: ", nal_unit)
#			if nal_unit == 7:
			if nal_unit == 0:
				print("change mode")
				image = change_image
				mode = change
		elif mode != change and change == "low":
			change_image = cam.getImagel()
#			nal_unit = change_image[10] & 0x1F
			nal_unit = change_image[4] & 0x1F
			print("Nal Unit: ", nal_unit)
#			if nal_unit == 7:
			if nal_unit == 0:
				print("change mode")
				image = change_image
				mode = change

		if image:
#			print("Image Length: ", len(image), ", Nal Unit: ", image[10] & 0x1F)
			await ws.send(image)
		await asyncio.sleep(0.01)

async def recv(ws):
	global change
	while True:
		data = await ws.recv()
		try:
			jsonObject = json.loads(data)
			bitrate = jsonObject.get("bitrate")
			if bitrate == "high":
				change = "high"
			elif bitrate == "mid":
				change = "mid"
			elif bitrate == "low":
				change = "low"
		except:
			pass

async def main():
	async with websockets.connect(url, ping_timeout=None)as ws:
		t1 = asyncio.create_task(send(ws))
		t2 = asyncio.create_task(recv(ws))
		await asyncio.gather(t1, t2)

asyncio.run(main())
